package factory;

/*
 * abstract data object module Buffer is Monitor
 *   general import from Item
 */
public class Buffer {

    private static final int SIZE = 3;
    private static Item[] storage = new Item[SIZE];
    private static int count = 0;
    private static int head = 0;
    private static int tail = 0;

    public static void write(Item item) throws InterruptedException {
        synchronized (storage) {
            if (isFull()) {
                System.out.println("B: Buffer full, cannot write. Need to wait!");
                storage.wait();
            }
            storage[tail] = item;
            tail = (tail + 1) % SIZE;
            count++;
            System.out.println("B: Buffer count " + count);
            storage.notify();
        }
    }

    public static Item read() throws InterruptedException {
        synchronized (storage) {
            if (isEmpty()) {
                System.out.println("B: Buffer empty, cannot read. Need to wait!");
                storage.wait();
            }
            Item item = storage[head];
            head = (head + 1) % SIZE;
            count--;
            System.out.println("B: Buffer count " + count);
            storage.notify();
            return item;
        }
    }

    public static boolean isEmpty() {
        return count == 0;
    }

    public static boolean isFull() {
        return count == SIZE;
    }
}

